<template>
    <section>

        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span class="h4" v-if="fail">
                    {{ fail.message }} <br>
                    <a href="#" class="btn btn-outline-primary mt-3" v-on:click.prevent="loadContent">Retry</a>
                </span>
            </div>
        </template>
        <template v-else>

            <span style="float: right; position: relative"><router-link v-bind:to="'/publisher/my-contents/' + content.id + '/edit'" class="font-weight-bold h5 mb-0"><i class="far fa-edit"></i> EDIT</router-link> </span>


            <h2 class="mb-2">
                {{ content.name }}
                <span class="h3 mb-0">
                    <i class="fab fa-android" v-if="content.type === 'android'"></i>
                    <i class="fab fa-telegram" v-else-if="content.type === 'telegram'"></i>
                    <i class="fas fa-globe" v-else-if="content.type === 'website'"></i>
                </span>
            </h2>


            <div class="card p-3 bg-secondary text-white">
                <h3 class="card-title">Performance</h3>
                <div class="card-body row">
                    <div class="col-3">
                        <span class="h3">{{ content.views }}</span>
                        <br>Impressions
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ content.clicks }}</span>
                        <br>Clicks
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ Number((content.clicks / content.views) * 100).toFixed(2) }} %</span>
                        <br>CTR
                    </div>

                    <div class="col-3">
                        <span class="h3">Br {{ Number((content.views * 0.5) + (content.clicks * 1.5)).toFixed(2) }}</span>
                        <br>Earning
                    </div>
                </div>
            </div>


            <h3 class="mt-3">Ad Units</h3>

            <span style="display: inline; float: right; position: relative"><router-link v-bind:to="'/publisher/my-contents/' + contentId + '/ad-units/new'" class="font-weight-bold h5 mb-0" v-if="content.type !== 'telegram'"><i class="far fa-plus-square"></i> ADD</router-link> </span>

            <div class="row">

                <template v-for="adUnit in adUnits">
                    <div class="col-md-3 p-1" v-on:click="adUnitClicked(adUnit.id)">
                        <div class="card">
                            <div class="card-header text-center py-4 bg-success">
                                <span class="text-white font-weight-bold h2 mb-0">{{ adUnit.size }}</span>
                            </div>
                            <div class="card-body">
                                <span class="card-title">{{ adUnit.name }}</span>
                            </div>
                        </div>

                    </div>
                </template>


            </div>

        </template>

    </section>
</template>

<script>
    export default {
        data : function () {
            return {
                contentId: this.$route.params.id,
                content: null,
                adUnits: null,

                // Loading flag
                loading: false,

                // Fail flag
                fail: false,
            }
        },
        methods: {
            loadContent: function () {
                // Show a loading
                this.loading = true;

                // Clear previous status flags
                this.fail = false;

                // Make a request to the server
                axios.get('/api/publisher/content/' + this.contentId)
                    .then(response => {
                        this.content = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        this.loading = false;

                        // Load the contents ad units
                        this.loadAdUnits();
                    });
            },
            loadAdUnits: function() {
                // Show a loading
                this.loading = true;

                // Clear previous status flags
                this.fail = false;

                // Make a request to the server
                axios.get('/api/publisher/content/' + this.contentId + '/adunit')
                    .then(response => {
                        this.adUnits = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        this.loading = false;
                    });
            },
            adUnitClicked: function (adUnitId) {
                this.$router.push('/publisher/my-contents/' + this.contentId + '/ad-units/' + adUnitId)
            }
        },
        watch: {
            '$route.params.id': function(id) {
                this.contentId = id;
                this.loadContent();
            }
        },
        mounted() {
            console.log('Publisher - Content Page mounted.');

            // Load the content
            this.loadContent();
        }
    }
</script>
